#define USE_FC_LEN_T
#include <R.h>
#include "Rmath.h"

extern "C" {

  void zhpevxC(char **jobz, char **range, char **uplo, int *n, Rcomplex *ap,
	      double *vl, double *vu, int *il, int *iu, double *abstol, int *m,
	      double *w, Rcomplex *z, int *ldz, Rcomplex *work, double *rwork,
	      int *iwork, int *ifail, int *info) {

	  char cjobz[2];
	  strncpy(cjobz, jobz[0], 1);
	  cjobz[1] = '\0';
	  char crange[2];
	  strncpy(crange, range[0], 1);
	  crange[1] = '\0';
	  char cuplo[2];
	  strncpy(cuplo, uplo[0], 1);
	  cuplo[1] = '\0';

          void F77_NAME(zhpevx)(char *jobz, char *range, char *uplo,
				       const int *n, Rcomplex *ap, const double *vl,
				       const double *vu, const int *il, const int *iu,
				       const double *abstol, int *m, double *w,
				       Rcomplex *z, const int *ldz, Rcomplex *work, double *rwork,
				       int *iwork, int *ifail, int *info,	
	  			       FC_LEN_T jobz_len,  FC_LEN_T range_len,  FC_LEN_T uplo_len);
	  
	  	  F77_CALL(zhpevx)(cjobz, crange, cuplo, &n[0], ap, &vl[0], &vu[0], &il[0], &iu[0], &abstol[0], &m[0],
	  			   w, z, &ldz[0], work, rwork, iwork, ifail, &info[0], strlen(cjobz), strlen(crange), strlen(cuplo));

  }

}

